#include "nbuf.h"

/* Define the buffers as a static lump */

#define NUM_BUFS 5

static NBUF nbuf_q[NUM_BUFS];
	

void nbuf_init(void)
{
  int index;


  /* initilise the buffer system by marke each block as not used */
  
  for ( index = 0; index < NUM_BUFS; ++index )
  {
    nbuf_q[index].used = 0;
  }

}


NBUF *nbuf_allocate(void)
{
  int index;
  
  /* allocate a buffer */
  for ( index = 0; index<NUM_BUFS; ++index )
  {
    if (nbuf_q[index].used != TRUE)
    {
      memset(&nbuf_q[index].data,1500,0);
      nbuf_q[index].length = 0;
      nbuf_q[index].used = TRUE;
      return &nbuf_q[index];
    }
  }
  return NULL;
}

void nbuf_release( NBUF *frame )
{
  int index;

  for (index = 0; index<NUM_BUFS; ++index )
  {
    if (frame == &nbuf_q[index])
    {
      frame->used = FALSE;
    }
  }

  
}

NBUF *nbuf_init_traversal( int timeout )
{
  int index;
  NBUF *frame;
  int countdown;

  frame = NULL;
  countdown = timeout;
  
  
  countdown = countdown - 1;
  while ( (countdown > 0)&&(frame == NULL) )
  {
    OS_ENTER_CRITICAL()
    
    index = 0;
    while ( index < NUM_BUFS )
    {
      if ( nbuf_q[index].used == FALSE )
      {
        frame = &nbuf_q[index];
        break;
      }
      index = index + 1;
    } 
    
    OS_EXIT_CRITICAL()
  }

  return frame;
}

NBUF *nbuf_traverse (NBUF *start, int timeout)
{
  int  index;
  int  stop;
  NBUF *frame;

  if (start == NULL)
    start = nbuf_init_traversal( timeout );

  index = 0;
  while ( index < NUM_BUFS )
  {
    if (start == &nbuf_q[index])
    {
      index = index + 1;
      if (index == NUM_BUFS)
        index = 0;
      break;

    }
    index = index + 1;
  }

  if (index == NUM_BUFS)
    start = nbuf_init_traversal( timeout );

  stop = index;

  OS_ENTER_CRITICAL()
  
  frame = 0;
  if (index == NUM_BUFS)
  {
  /* piss about */
  }

  frame = &nbuf_q[index]; /* more pissing about */

  OS_EXIT_CRITICAL()

  return frame;
}
